library messages2;

//this comes with NO WARRANTY and is protected by GNU PUBLIC LICENCE v2 or better
//check gpl.txt for more details
uses
  SysUtils,
  Classes,
  Windows;

{$R *.res}
function GetTok(data: string; value: integer; token: Integer): string; //thx to [ATS] for this function
var
  temp_str: string;
  a: integer;
  tok: string;
begin
  temp_str := '';
  a := 0;
  tok:= Chr(token);
  while value > 0 do
  begin
  if ((data[a] = tok) or (a > length(data))) then dec(value)
  else if value = 1 then temp_str := temp_str + data[a];
  inc(a);
  end;
  result := temp_str;
end;

function isin(str: string; str2: string): Boolean;
var n: integer; m: cardinal; vaka: Boolean;
begin
  n:= 0;
  m:= Length(str);
  while n <= m do
  begin
    if str[n] = str2 then vaka:= TRUE;
    inc(n);
  end;
  if not vaka = true then result:= FALSE
  else result:= vaka;
end;

function MsgBox(mWnd: hWnd;aWnd: hWnd;Data: PChar;Parms: PChar;Show: Boolean;NoPause: Boolean): Integer;export;stdcall
//syntax: $dll(messages2.dll, MsgBox, <flags>;<title>;<text>)
// flags:
//      y: creates a yes\no message box
//      a: creates an about\retry\ignore message box
//      c: creates a yes\no\cancel message box
//      m: creates a normal message box
//      i: creates an info icon (a lowercase itallic "i")
//      e: creates an error icon (a stop)
//      w: creates an warn icon ("!")
//      q: creates an question icon ("?")
var
  toreturn: PChar;returned: Integer;flags: string;intflags: integer;title: PChar;txt: PChar;
begin
  flags:= GetTok(string(data),1,32);
  intflags:= 0;
  if isin(flags,'y') = TRUE then intflags:= intflags + MB_YESNO;
  if isin(flags,'a') = TRUE then intflags:= intflags + MB_ABORTRETRYIGNORE;
  if isin(flags,'c') = TRUE then intflags:= intflags + MB_YESNOCANCEL;
  if isin(flags,'m') = TRUE then intflags:= MB_OK;
  if isin(flags,'i') = TRUE then intflags:= intflags + MB_ICONINFORMATION;
  if isin(flags,'e') = TRUE then intflags:= intflags + MB_ICONERROR;
  if isin(flags,'w') = TRUE then intflags:= intflags + MB_ICONWARNING;
  if isin(flags,'q') = TRUE then intflags:= intflags + MB_ICONQUESTION;
  //here we go, now pray (pray? but i'm heretic :P)
  title:= pchar(GetTok(string(data),2,59));
  txt:= pchar(GetTok(string(data),3,59));
  returned:= MessageBox(mWnd,txt,title,intflags);
  case returned of
    0: toreturn:= 'ERROR';
    IDABORT: toreturn:= 'ABORT';
    IDCANCEL: toreturn:= 'CANCEL';
    IDIGNORE: toreturn:= 'IGNORE';
    IDNO: toreturn:= 'NO';
    IDOK: toreturn:= 'OK';
    IDRETRY: toreturn:= 'RETRY';
    IDYES: toreturn:= 'YES';
  else
    toreturn:= 'ERROR';
  end;
  StrCopy(data,toreturn);
  result:= 3;
end;

function Beep(mWnd: hWnd;aWnd: hWnd;Data: PChar;Parms: PChar;Show: Boolean;NoPause: Boolean): Integer;export;stdcall
var beeptype: integer;
begin
    if data = 'INFO' then beeptype:= MB_ICONASTERISK;
    if data = 'WARN' then beeptype:= MB_ICONEXCLAMATION;
    if data = 'ERROR' then beeptype:= MB_ICONHAND;
    if data = 'QUESTION' then beeptype:= MB_ICONQUESTION;
    if data = 'DEFAULT' then beeptype:= MB_OK;
    MessageBeep(beeptype);
    result:= 1;
end;

function DllInfo(mWnd: hWnd;aWnd: hWnd;Data: PChar;Parms: PChar;Show: Boolean;NoPause: Boolean): Integer;export;stdcall
begin
  StrCopy(data,'Messages2.dll v2.0b by: heretic(heretic@mail.pt)');
  result:= 3;
end;

exports
  MsgBox,Beep,DllInfo;

begin
end.
 